#!/usr/bin/env python
# -*- coding: utf-8 -*-
print "Content-Type: text/html; charset=utf-8\n"

import pysolr
import cgi
import sys
import types
import urllib

request = cgi.FieldStorage()

unique_key = "url"
default_start = 0
default_rows = 10
default_fq = []
default_fl = "*,score"
default_facet = "true"
default_facet_field = ["genre"]
default_facet_mincount = 1
default_hl = "true"
default_hl_fl = "title,summary"
default_hl_snipets = 2
default_hl_simple_pre = "<strong>"
default_hl_simple_post = "</strong>"

start = int(request["start"].value) if request.has_key("start") else default_start
rows = int(request["rows"].value) if request.has_key("rows") else default_rows
query = request["q"].value if request.has_key("q") else ""
fq = default_fq
if request.has_key("fq"):
	if isinstance(request["fq"], types.ListType):
		for mfs in request["fq"]:
			fq.append(mfs.value)
	else:
		fq.append(request["fq"].value)
fl = request["fl"].value if request.has_key("fl") else default_fl
facet = request["facet"].value if request.has_key("facet") else default_facet
facet_field = default_facet_field
if request.has_key("facet.field"):
	if isinstance(request["facet.field"], types.ListType):
		for mfs in request["facet.field"]:
			facet_field.append(mfs.value)
	else:
		facet_field.append(request["facet.field"].value)
facet_mincount = int(request["facet.mincount"].value) if request.has_key("facet.mincount") else default_facet_mincount
hl = request["hl"].value if request.has_key("hl") else default_hl
hl_fl = request["hl.fl"].value if request.has_key("hl.fl") else default_hl_fl
hl_snipets = int(request["hl.snipets"].value) if request.has_key("hl.snipets") else default_hl_snipets
hl_simple_pre = request["hl.simple.pre"].value if request.has_key("hl.simple.pre") else default_hl_simple_pre
hl_simple_post = request["hl.simple.post"].value if request.has_key("hl.simple.post") else default_hl_simple_post
result = None

params = {
	"start" : start,
	"rows" : rows,
	"fq" : fq,
	"fl" : fl,
	"facet" : facet,
	"facet.field" : facet_field,
	"facet.mincount" : facet_mincount,
	"hl" : hl,
	"hl.fl" : hl_fl,
	"hl.simple.pre" : hl_simple_pre,
	"hl.simple.post" : hl_simple_post,
}

if query:
	solr = pysolr.Solr('http://localhost:8983/solr/solrbook')
	try:
		result = solr.search(query, **params)
	except Exception, e:
		print "<html><head><title>SEARCH EXCEPTION</title><body><pre>" + e.message + "</pre></body></html>"
		sys.exit(1)

print "<html>"
print "	<head>"
print "		<link rel=\"stylesheet\" href=\"./search.css\" type=\"text/css\" />"
print "		<title>Python Solr Client Example</title>"
print "	</head>"
print "	<body>"

print "		<div id=\"container\"><!-- start container -->"
print "			<div id=\"head\"><!-- start head -->"
print "				Python Solr Client Example"
print "				<div id=\"searchbox\"><!-- start searchbox -->"
print "					<form accept-charset=\"utf-8\" method=\"get\">"
print "						<label for=\"q\">Search:</label>"
print "						<input id=\"q\" name=\"q\" size=\"100\" type=\"text\" value=\"" + cgi.escape(query) + "\"/>"
print "						<input id=\"start\" name=\"start\" type=\"hidden\" value=\"" + cgi.escape(str(default_start)) + "\"/>"
print "						<input id=\"rows\" name=\"rows\" type=\"hidden\" value=\"" + cgi.escape(str(rows)) + "\"/>"
print "						<input id=\"fl\" name=\"fl\" type=\"hidden\" value=\"" + cgi.escape(fl) + "\"/>"
print "						<input id=\"facet\" name=\"facet\" type=\"hidden\" value=\"" + cgi.escape(facet) + "\"/>"
for ff in facet_field:
	print "						<input id=\"facet_field\" name=\"facet.field\" type=\"hidden\" value=\"" + cgi.escape(ff) + "\"/>"
print "						<input id=\"facet_mincount\" name=\"facet.mincount\" type=\"hidden\" value=\"" + cgi.escape(str(facet_mincount)) + "\"/>"
print "						<input id=\"hl\" name=\"hl\" type=\"hidden\" value=\"" + cgi.escape(hl) + "\"/>"
print "						<input id=\"hl_fl\" name=\"hl.fl\" type=\"hidden\" value=\"" + cgi.escape(hl_fl) + "\"/>"
print "						<input id=\"hl_simple_pre\" name=\"hl.simple.pre\" type=\"hidden\" value=\"" + cgi.escape(hl_simple_pre) + "\"/>"
print "						<input id=\"hl_simple_post\" name=\"hl.simple.post\" type=\"hidden\" value=\"" + cgi.escape(hl_simple_post) + "\"/>"
print "						<input type=\"submit\"/>"
print "					</form>"
print "				</div><!-- end searchbox -->"
print "			</div><!-- end head -->"

print "			<div id=\"main\"><!-- start main -->"
print "				<div id=\"searchresult\"><!-- start searchresult -->"

if result != None:
	total_num = result.hits
	disp_start_num = min(start + 1, total_num)
	disp_end_num = min (start + rows, total_num)
	print "					<div id=\"pageinfo\"><!-- start pageinfo -->"
	print "						Results " + cgi.escape(str(disp_start_num)) + " - " + cgi.escape(str(disp_end_num)) + " of " + cgi.escape(str(total_num)) + ":"
	print "					</div><!-- end pageinfo -->"
	for doc in result:
		print "					<div id=\"document\"><!-- start document -->"
		key = ""
		for field in doc.keys():
			if field == unique_key:
				key = doc[field]
		for field in doc.keys():
			print "						<div id=\"field\"><!-- start field -->"
			print "							<span id=\"fieldname\"><!-- start fieldname -->"
			print "								" + cgi.escape(field) + ":&nbsp;"
			print "							</span><!-- end fieldname -->"
			print "							<span id=\"fieldvalue\"><!-- start fieldname -->"
			
			highlight_text = ""
			if result.highlighting.has_key(key) and result.highlighting[key].has_key(field):
				highlight_text = u" ... ".join(result.highlighting[key][field])
			
			if highlight_text:
				print "								" + highlight_text.encode('utf-8')
			elif isinstance(doc[field], types.ListType):
				value_list = []
				for value in doc[field]:
					value_list.append(value.encode('utf-8'))
				print "								" + ", ".join(value_list)
			elif isinstance(doc[field], types.UnicodeType):
				print "								" + doc[field].encode('utf-8')
			else:
				print "								" + unicode(str(doc[field]), 'utf-8').encode('utf-8')
			print "							</span><!-- end fieldvalue -->"
			print "						</div><!-- end field -->"
		print "					</div><!-- end document -->"
	
	print "					<div id=\"pagination\"><!-- start pagenation -->"
	
	wsiz = 10
	w1 = 5
	w2 = 5
	
	pcnt = total_num / rows + (0 if (total_num % rows) == 0 else 1)
	cpag = start / rows + 1
	wbgn = cpag - w1
	wend = cpag + w2
	
	if wbgn < 1:
		wbgn = 1
		wend = wbgn + wsiz
		if wend > pcnt + 1:
			wend = pcnt + 1
	if wend > pcnt + 1:
		wend = pcnt + 1
		wbgn = wend - wsiz
		if wbgn < 1:
			wbgn = 1
	
	if cpag > 1:
		link = "./search.py?"
		link = link + "q=" + urllib.quote(query)
		for q in fq:
			link = link + "&fq=" + urllib.quote(q)
		link = link + "&start=" + urllib.quote(str((cpag - 2) * rows))
		link = link + "&rows=" + urllib.quote(str(rows))
		link = link + "&fl=" + urllib.quote(fl)
		link = link + "&facet=" + urllib.quote(facet)
		for ff in facet_field:
			link = link + "&facet.field=" + urllib.quote(ff)
		link = link + "&facet.mincount=" + urllib.quote(str(facet_mincount))
		print "						<a href=\"" + cgi.escape(link) + "\">&lt;&lt;</a>&nbsp;"
	
	for i in xrange(wbgn, wend):
		if cpag == i:
			print "						&nbsp;" + cgi.escape(str(i)) + "&nbsp;"
		else:
			link = "./search.py?"
			link = link + "q=" + urllib.quote(query)
			for q in fq:
				link = link + "&fq=" + urllib.quote(q)
			link = link + "&start=" + urllib.quote(str((i - 1) * rows))
			link = link + "&rows=" + urllib.quote(str(rows))
			link = link + "&fl=" + urllib.quote(fl)
			link = link + "&facet=" + urllib.quote(facet)
			for ff in facet_field:
				link = link + "&facet.field=" + urllib.quote(ff)
			link = link + "&facet.mincount=" + urllib.quote(str(facet_mincount))
			print "						&nbsp;<a href=\"" + cgi.escape(link) + "\">" + urllib.quote(str(i)) + "</a>&nbsp;"
	
	if cpag < pcnt:
		link = "./search.py?"
		link = link + "q=" + urllib.quote(query)
		for q in fq:
			link = link + "&fq=" + urllib.quote(q)
		link = link + "&start=" + urllib.quote(str(cpag * rows))
		link = link + "&rows=" + urllib.quote(str(rows))
		link = link + "&fl=" + urllib.quote(fl)
		link = link + "&facet=" + urllib.quote(facet)
		for ff in facet_field:
			link = link + "&facet.field=" + urllib.quote(ff)
		link = link + "&facet.mincount=" + urllib.quote(str(facet_mincount))
		print "						<a href=\"" + cgi.escape(link) + "\">&gt;&gt;</a>&nbsp;"
	
	print "					</div><!-- end pagenation -->"

print "				</div><!-- end searchresult -->"
print "			</div><!-- end main -->"

if result != None:
	if facet == "true":
		print "			<div id=\"left\"><!-- start left -->"
		for facet_type in result.facets.keys():
			for field in result.facets[facet_type].keys():
				print "				<div id=\"facet\"><!-- start facet -->"
				print "					" + cgi.escape(field)
				i = 0
				while i < len(result.facets[facet_type][field]):
					link = "./search.py?"
					link = link + "q=" + urllib.quote(query)
					for q in fq:
						link = link + "&fq=" + urllib.quote(str(q))
					if result.facets[facet_type][field][i].find(" ") >= 0:
						link = link + "&fq=" + urllib.quote(field.encode('utf-8') + ":\"" + (result.facets[facet_type][field][i]).encode('utf-8') + "\"")
					else:
						link = link + "&fq=" + urllib.quote(field.encode('utf-8') + ":" + (result.facets[facet_type][field][i]).encode('utf-8'))
					link = link + "&start=" + urllib.quote(str(default_start))
					link = link + "&rows=" + urllib.quote(str(rows))
					link = link + "&fl=" + urllib.quote(fl)
					link = link + "&facet=" + urllib.quote(facet)
					for ff in facet_field:
						link = link + "&facet.field=" + urllib.quote(ff)
					link = link + "&facet.mincount=" + urllib.quote(str(facet_mincount))
					print "					<div id=\"facet_value\"><!-- start facet_value -->"
					print "						<a href=\"" + cgi.escape(link) + "\">" + cgi.escape((result.facets[facet_type][field][i]).encode('utf-8')) + "</a>&nbsp;(" + cgi.escape(str(result.facets[facet_type][field][i + 1])) + ")"
					print "					</div><!-- end facet_value -->"
					i += 2
				print "				</div><!-- end facet -->"
		print "			</div><!-- end left -->"

print "			<div id=\"foot\"><!-- start foot -->"
print "				sample"
print "			</div><!-- end foot -->"
print "		</div><!-- end container -->"
print "	</body>"
print "</html>"
